Overview | Package | Class | Use | Tree | Deprecated | Index | Help
|  | BEA Systems, Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## weblogic.apache.xml.utils
Class ListingErrorHandler

    java.lang.Object
      |
      +--weblogic.apache.xml.utils.ListingErrorHandler

public class ListingErrorHandler
extends java.lang.Object
implements org.xml.sax.ErrorHandler, javax.xml.transform.ErrorListener

Sample implementation of similar SAX ErrorHandler and JAXP ErrorListener.

This implementation is suitable for various use cases, and provides some basic configuration API's as well to control when we re-throw errors, etc.

This class is based on an implementation from the Apache XML Project. In future releases the XML parser, XSLT processor, and associated classes will likely be updated to be based on a later version of the Apache implementations. Since Apache does not guarantee backwards compatibility between versions of their software, we cannot guarantee backwards compatibility of any of the classes contained in the weblogic.apache package or sub-packages.

Version:
  $Id: ListingErrorHandler.java,v 1.1 2001/12/20 21:15:15 curcuru Exp $
Author:
  shane_curcuru@us.ibm.com

Field Summary
`protected java.io.PrintWriter` | `m_pw`
`protected boolean` | `throwOnError` If we should throw exception on errors; default:true.
`protected boolean` | `throwOnFatalError` If we should throw exception on fatalErrors; default:true.
`protected boolean` | `throwOnWarning` If we should throw exception on warnings; default:false.

Constructor Summary
`ListingErrorHandler()` Constructor ListingErrorHandler; uses System.err.
`ListingErrorHandler(java.io.PrintWriter pw)` Constructor ListingErrorHandler; user-supplied PrintWriter.

Method Summary
`void` | `error(org.xml.sax.SAXParseException exception)` Receive notification of a recoverable error.
`void` | `error(javax.xml.transform.TransformerException exception)` Receive notification of a recoverable error.
`void` | `fatalError(org.xml.sax.SAXParseException exception)` Receive notification of a non-recoverable error.
`void` | `fatalError(javax.xml.transform.TransformerException exception)` Receive notification of a non-recoverable error.
`protected static java.lang.String` | `getSourceLine(java.lang.String sourceUrl, int lineNum)` Return the specific source line that caused the exception, if possible to load it; allow exceptions to be thrown.
`boolean` | `getThrowOnError()` User-settable behavior: when to re-throw exceptions.
`boolean` | `getThrowOnFatalError()` User-settable behavior: when to re-throw exceptions.
`boolean` | `getThrowOnWarning()` User-settable behavior: when to re-throw exceptions.
`static void` | `logExceptionLocation(java.io.PrintWriter pw, java.lang.Throwable exception)` Print out location information about the exception.
`static void` | `logSourceLine(java.io.PrintWriter pw, javax.xml.transform.SourceLocator locator)` Print out the specific source line that caused the exception, if possible to load it.
`void` | `setThrowOnError(boolean b)` User-settable behavior: when to re-throw exceptions.
`void` | `setThrowOnFatalError(boolean b)` User-settable behavior: when to re-throw exceptions.
`void` | `setThrowOnWarning(boolean b)` User-settable behavior: when to re-throw exceptions.
`void` | `warning(org.xml.sax.SAXParseException exception)` Receive notification of a warning.
`void` | `warning(javax.xml.transform.TransformerException exception)` Receive notification of a warning.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### m_pw

    protected java.io.PrintWriter m_pw

### throwOnWarning

    protected boolean throwOnWarning

  If we should throw exception on warnings; default:false.

### throwOnError

    protected boolean throwOnError

  If we should throw exception on errors; default:true.

### throwOnFatalError

    protected boolean throwOnFatalError

  If we should throw exception on fatalErrors; default:true.

Constructor Detail

### ListingErrorHandler

    public ListingErrorHandler(java.io.PrintWriter pw)

  Constructor ListingErrorHandler; user-supplied PrintWriter.

### ListingErrorHandler

    public ListingErrorHandler()

  Constructor ListingErrorHandler; uses System.err.

Method Detail

### warning

    public void warning(org.xml.sax.SAXParseException exception)
                 throws org.xml.sax.SAXException

  Receive notification of a warning.

  SAX parsers will use this method to report conditions that are not errors or fatal errors as defined by the XML 1.0 recommendation. The default behaviour is to take no action.

  The SAX parser must continue to provide normal parsing events after invoking this method: it should still be possible for the application to process the document through to the end.

  Filters may use this method to report other, non-XML warnings as well.

  Specified by:
    warning in interface org.xml.sax.ErrorHandler

  Parameters:
    `exception` - The warning information encapsulated in a SAX parse exception.
  Throws:
    org.xml.sax.SAXException - Any SAX exception, possibly wrapping another exception; only if setThrowOnWarning is true.
  See Also:
    `SAXParseException`

### error

    public void error(org.xml.sax.SAXParseException exception)
               throws org.xml.sax.SAXException

  Receive notification of a recoverable error.

  This corresponds to the definition of "error" in section 1.2 of the W3C XML 1.0 Recommendation. For example, a validating parser would use this callback to report the violation of a validity constraint. The default behaviour is to take no action.

  The SAX parser must continue to provide normal parsing events after invoking this method: it should still be possible for the application to process the document through to the end. If the application cannot do so, then the parser should report a fatal error even if the XML 1.0 recommendation does not require it to do so.

  Filters may use this method to report other, non-XML errors as well.

  Specified by:
    error in interface org.xml.sax.ErrorHandler

  Parameters:
    `exception` - The error information encapsulated in a SAX parse exception.
  Throws:
    org.xml.sax.SAXException - Any SAX exception, possibly wrapping another exception; only if setThrowOnErroris true.
  See Also:
    `SAXParseException`

### fatalError

    public void fatalError(org.xml.sax.SAXParseException exception)
                    throws org.xml.sax.SAXException

  Receive notification of a non-recoverable error.

  This corresponds to the definition of "fatal error" in section 1.2 of the W3C XML 1.0 Recommendation. For example, a parser would use this callback to report the violation of a well-formedness constraint.

  The application must assume that the document is unusable after the parser has invoked this method, and should continue (if at all) only for the sake of collecting addition error messages: in fact, SAX parsers are free to stop reporting any other events once this method has been invoked.

  Specified by:
    fatalError in interface org.xml.sax.ErrorHandler

  Parameters:
    `exception` - The error information encapsulated in a SAX parse exception.
  Throws:
    org.xml.sax.SAXException - Any SAX exception, possibly wrapping another exception; only if setThrowOnFatalError is true.
  See Also:
    `SAXParseException`

### warning

    public void warning(javax.xml.transform.TransformerException exception)
                 throws javax.xml.transform.TransformerException

  Receive notification of a warning.

  `Transformer` can use this method to report conditions that are not errors or fatal errors. The default behaviour is to take no action.

  After invoking this method, the Transformer must continue with the transformation. It should still be possible for the application to process the document through to the end.

  Specified by:
    warning in interface javax.xml.transform.ErrorListener

  Parameters:
    `exception` - The warning information encapsulated in a transformer exception.
  Throws:
    javax.xml.transform.TransformerException - only if setThrowOnWarning is true.
  See Also:
    `TransformerException`

### error

    public void error(javax.xml.transform.TransformerException exception)
               throws javax.xml.transform.TransformerException

  Receive notification of a recoverable error.

  The transformer must continue to try and provide normal transformation after invoking this method. It should still be possible for the application to process the document through to the end if no other errors are encountered.

  Specified by:
    error in interface javax.xml.transform.ErrorListener

  Parameters:
    `exception` - The error information encapsulated in a transformer exception.
  Throws:
    javax.xml.transform.TransformerException - only if setThrowOnError is true.
  See Also:
    `TransformerException`

### fatalError

    public void fatalError(javax.xml.transform.TransformerException exception)
                    throws javax.xml.transform.TransformerException

  Receive notification of a non-recoverable error.

  The transformer must continue to try and provide normal transformation after invoking this method. It should still be possible for the application to process the document through to the end if no other errors are encountered, but there is no guarantee that the output will be useable.

  Specified by:
    fatalError in interface javax.xml.transform.ErrorListener

  Parameters:
    `exception` - The error information encapsulated in a transformer exception.
  Throws:
    javax.xml.transform.TransformerException - only if setThrowOnError is true.
  See Also:
    `TransformerException`

### logExceptionLocation

    public static void logExceptionLocation(java.io.PrintWriter pw,
                                            java.lang.Throwable exception)

  Print out location information about the exception. Cribbed from DefaultErrorHandler.printLocation()

  Parameters:
    `pw` - PrintWriter to send output to
    `exception` - TransformerException or SAXParseException to log information about

### logSourceLine

    public static void logSourceLine(java.io.PrintWriter pw,
                                     javax.xml.transform.SourceLocator locator)

  Print out the specific source line that caused the exception, if possible to load it.

  Parameters:
    `pw` - PrintWriter to send output to
    `locator` - Xalan wrapper for either a JAXP or a SAX source location object

### getSourceLine

    protected static java.lang.String getSourceLine(java.lang.String sourceUrl,
                                                    int lineNum)
                                             throws java.lang.Exception

  Return the specific source line that caused the exception, if possible to load it; allow exceptions to be thrown.

### setThrowOnWarning

    public void setThrowOnWarning(boolean b)

  User-settable behavior: when to re-throw exceptions.

  This allows per-instance configuration of ListingErrorHandlers. You can ask us to either throw an exception when we're called for various warning / error / fatalErrors, or simply log them and continue.

  Parameters:
    `t` - if we should throw an exception on warnings

### getThrowOnWarning

    public boolean getThrowOnWarning()

  User-settable behavior: when to re-throw exceptions.

  Returns:
    if we throw an exception on warnings

### setThrowOnError

    public void setThrowOnError(boolean b)

  User-settable behavior: when to re-throw exceptions.

  This allows per-instance configuration of ListingErrorHandlers. You can ask us to either throw an exception when we're called for various warning / error / fatalErrors, or simply log them and continue.

  Note that the behavior of many parsers/transformers after an error is not necessarily defined!

  Parameters:
    `t` - if we should throw an exception on errors

### getThrowOnError

    public boolean getThrowOnError()

  User-settable behavior: when to re-throw exceptions.

  Returns:
    if we throw an exception on errors

### setThrowOnFatalError

    public void setThrowOnFatalError(boolean b)

  User-settable behavior: when to re-throw exceptions.

  This allows per-instance configuration of ListingErrorHandlers. You can ask us to either throw an exception when we're called for various warning / error / fatalErrors, or simply log them and continue.

  Note that the behavior of many parsers/transformers after a fatalError is not necessarily defined, most products will probably barf if you continue.

  Parameters:
    `t` - if we should throw an exception on fatalErrors

### getThrowOnFatalError

    public boolean getThrowOnFatalError()

  User-settable behavior: when to re-throw exceptions.

  Returns:
    if we throw an exception on fatalErrors

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Documentation is available at http://e-docs.bea.com/wls/docs70
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2004 BEA Systems, Inc. All Rights Reserved.
WebLogic Server 7.0 API Reference